
<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
		<style>
			body {
				background: black;
				color: rgb(80, 80, 80);
			}
			body, pre, #legend span {
				font-family: Menlo, monospace;
				font-weight: bold;
			}
			#topbar {
				background: black;
				position: fixed;
				top: 0; left: 0; right: 0;
				height: 42px;
				border-bottom: 1px solid rgb(80, 80, 80);
			}
			#content {
				margin-top: 50px;
			}
			#nav, #legend {
				float: left;
				margin-left: 10px;
			}
			#legend {
				margin-top: 12px;
			}
			#nav {
				margin-top: 10px;
			}
			#legend span {
				margin: 0 5px;
			}
			.cov0 { color: rgb(192, 0, 0) }
.cov1 { color: rgb(128, 128, 128) }
.cov2 { color: rgb(116, 140, 131) }
.cov3 { color: rgb(104, 152, 134) }
.cov4 { color: rgb(92, 164, 137) }
.cov5 { color: rgb(80, 176, 140) }
.cov6 { color: rgb(68, 188, 143) }
.cov7 { color: rgb(56, 200, 146) }
.cov8 { color: rgb(44, 212, 149) }
.cov9 { color: rgb(32, 224, 152) }
.cov10 { color: rgb(20, 236, 155) }

		</style>
	</head>
	<body>
		<div id="topbar">
			<div id="nav">
				<select id="files">
				
				<option value="file0">gitlab.com/editorservice/backend/editor/connections/connections.go (66.7%)</option>
				
				<option value="file1">gitlab.com/editorservice/backend/editor/impl/editor.go (77.6%)</option>
				
				<option value="file2">gitlab.com/editorservice/backend/editor/impl/server.go (77.8%)</option>
				
				<option value="file3">gitlab.com/editorservice/backend/editor/model/article.go (78.4%)</option>
				
				<option value="file4">gitlab.com/editorservice/backend/editor/model/user.go (100.0%)</option>
				
				</select>
			</div>
			<div id="legend">
				<span>not tracked</span>
			
				<span class="cov0">not covered</span>
				<span class="cov8">covered</span>
			
			</div>
		</div>
		<div id="content">
		
		<pre class="file" id="file0" style="display: none">package connections

import (
        "os"
)

const (
        NameDB            = "editor"
        UserCollection    = "user"
        ArticleCollection = "article"
)

var (
        EditorServiceUrl = getEnv("EDITOR_SERVICE_URL", "127.0.0.1:10000")
        MongoConnect     = getEnv("MONGO_CONNECT", "mongodb://localhost:27017")
)

func getEnv(key string, defaultVal string) string <span class="cov8" title="1">{
        if value, exists := os.LookupEnv(key); exists </span><span class="cov0" title="0">{
                return value
        }</span>
        <span class="cov8" title="1">return defaultVal</span>
}
</pre>
		
		<pre class="file" id="file1" style="display: none">package impl

import (
        "context"
        editor "gitlab.com/editorservice/backend/editor/api"
        "gitlab.com/editorservice/backend/editor/model"
        "go.mongodb.org/mongo-driver/bson/primitive"
        "time"
)

func (server *serverImpl) GetArticle(ctx context.Context, request *editor.GetArticleRequest) (*editor.GetArticleResponse, error) <span class="cov8" title="1">{
        //TODO: check user's role
        requiredRole := ""
        access, err := checkRole(userCollection, request.GetUser().GetId(), requiredRole)
        if !access </span><span class="cov0" title="0">{
                return &amp;editor.GetArticleResponse{
                        Article: nil,
                }, err
        }</span>

        <span class="cov8" title="1">id, _ := primitive.ObjectIDFromHex(request.GetArticleId())
        article, err := articleCollection.Get(id)

        if err != nil </span><span class="cov8" title="1">{
                return &amp;editor.GetArticleResponse{
                        Article: nil,
                }, err
        }</span>

        <span class="cov8" title="1">if article != nil </span><span class="cov8" title="1">{
                return &amp;editor.GetArticleResponse{
                        Article: model.RenderArticleModel(article),
                }, nil
        }</span> else<span class="cov0" title="0"> {
                return &amp;editor.GetArticleResponse{
                        Article: nil,
                }, err
        }</span>
}

func (server *serverImpl) GetListArticle(ctx context.Context, request *editor.GetListArticleRequest) (*editor.GetListArticleResponse, error) <span class="cov0" title="0">{
        articles, err := articleCollection.GetList()

        if err != nil </span><span class="cov0" title="0">{
                return nil, err
        }</span>

        <span class="cov0" title="0">return &amp;editor.GetListArticleResponse{
                Article: model.RenderListArticleModel(articles),
        }, nil</span>
}

func (server *serverImpl) CreateArticle(ctx context.Context, request *editor.CreateArticleRequest) (*editor.CreateArticleResponse, error) <span class="cov8" title="1">{
        //TODO: check user's role
        requiredRole := ""
        access, err := checkRole(userCollection, request.GetUser().GetId(), requiredRole)
        if !access </span><span class="cov0" title="0">{
                return &amp;editor.CreateArticleResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">newArticle := model.RenderBackArticleModel(request.Article)
        err = articleCollection.Create(newArticle)

        if err != nil </span><span class="cov0" title="0">{
                return &amp;editor.CreateArticleResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">return &amp;editor.CreateArticleResponse{
                Success: true,
        }, nil</span>
}

func (server *serverImpl) DeleteArticle(ctx context.Context, request *editor.DeleteArticleRequest) (*editor.DeleteArticleResponse, error) <span class="cov8" title="1">{
        //TODO: check user's role
        requiredRole := ""
        access, err := checkRole(userCollection, request.GetUser().GetId(), requiredRole)
        if !access </span><span class="cov0" title="0">{
                return &amp;editor.DeleteArticleResponse{
                        Access: false,
                }, err
        }</span>

        <span class="cov8" title="1">id, _ := primitive.ObjectIDFromHex(request.GetArticleId())
        err = articleCollection.Delete(id)

        if err != nil </span><span class="cov0" title="0">{
                return &amp;editor.DeleteArticleResponse{
                        Access: true,
                }, err
        }</span>

        <span class="cov8" title="1">return &amp;editor.DeleteArticleResponse{
                Access: true,
        }, nil</span>
}

func (server *serverImpl) EditArticle(ctx context.Context, request *editor.EditArticleRequest) (*editor.EditArticleResponse, error) <span class="cov8" title="1">{
        //TODO: check user's role
        requiredRole := ""
        access, err := checkRole(userCollection, request.GetUser().GetId(), requiredRole)
        if !access </span><span class="cov0" title="0">{
                return &amp;editor.EditArticleResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">id, _ := primitive.ObjectIDFromHex(request.GetArticle().GetId())

        article, err := articleCollection.Get(id)
        if err != nil || article == nil </span><span class="cov0" title="0">{
                return &amp;editor.EditArticleResponse{
                        Success: false,
                }, err
        }</span>
        <span class="cov8" title="1">updatedArticle := model.RenderBackArticleModel(request.GetArticle())
        updatedArticle.CurrentVersion += 1

        lastVersion := &amp;model.Version{
                Article:   article,
                CreatedAt: article.CreatedAt,
        }
        updatedArticle.Versions = append(updatedArticle.Versions, lastVersion)
        updatedArticle.UpdatedAt = time.Now().Format("2 January 2006 15:04")

        err = articleCollection.Update(updatedArticle)
        if err != nil </span><span class="cov0" title="0">{
                return &amp;editor.EditArticleResponse{
                        Success: false,
                }, err
        }</span>
        <span class="cov8" title="1">return &amp;editor.EditArticleResponse{
                Success: true,
        }, err</span>
}

func (server *serverImpl) InsertToArticle(ctx context.Context, request *editor.InsertToArticleRequest) (*editor.InsertToArticleResponse, error) <span class="cov8" title="1">{
        //TODO: check user's role
        requiredRole := ""
        access, err := checkRole(userCollection, request.GetUser().GetId(), requiredRole)
        if !access </span><span class="cov0" title="0">{
                return &amp;editor.InsertToArticleResponse{
                        Success:   false,
                        ArticleId: "",
                }, err
        }</span>

        <span class="cov8" title="1">mainArticleID, _ := primitive.ObjectIDFromHex(request.GetMainArticleId())
        attachedArticleID, _ := primitive.ObjectIDFromHex(request.GetNewArticle().GetId())

        article, err := articleCollection.Get(mainArticleID)
        if err != nil || article == nil </span><span class="cov0" title="0">{
                return &amp;editor.InsertToArticleResponse{
                        Success:   false,
                        ArticleId: "",
                }, err
        }</span>
        <span class="cov8" title="1">article.AttachedArticles = append(
                article.AttachedArticles,
                model.RenderBackArticleModel(request.GetNewArticle()))

        err = articleCollection.Update(article)
        if err != nil </span><span class="cov0" title="0">{
                return &amp;editor.InsertToArticleResponse{
                        Success:   false,
                        ArticleId: "",
                }, err
        }</span>

        <span class="cov8" title="1">err = articleCollection.Delete(attachedArticleID)
        if err != nil </span><span class="cov0" title="0">{
                return &amp;editor.InsertToArticleResponse{
                        Success:   false,
                        ArticleId: mainArticleID.String(),
                }, err
        }</span>

        <span class="cov8" title="1">return &amp;editor.InsertToArticleResponse{
                Success:   true,
                ArticleId: mainArticleID.String(),
        }, nil</span>
}

func (server *serverImpl) CommentArticle(ctx context.Context, request *editor.CommentArticleRequest) (*editor.CommentArticleResponse, error) <span class="cov8" title="1">{
        //TODO: check user's role
        requiredRole := ""
        access, err := checkRole(userCollection, request.GetUser().GetId(), requiredRole)
        if !access </span><span class="cov0" title="0">{
                return &amp;editor.CommentArticleResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">id, _ := primitive.ObjectIDFromHex(request.GetArticleId())

        article, err := articleCollection.Get(id)
        if err != nil || article == nil </span><span class="cov0" title="0">{
                return &amp;editor.CommentArticleResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">article.Comments = append(article.Comments, model.RenderBackArticleCommentModel(request.GetComment()))
        err = articleCollection.Update(article)

        if err != nil </span><span class="cov0" title="0">{
                return &amp;editor.CommentArticleResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">return &amp;editor.CommentArticleResponse{
                Success: true,
        }, nil</span>
}

func (server *serverImpl) EditCommentArticle(ctx context.Context, request *editor.EditCommentArticleRequest) (*editor.EditCommentArticleResponse, error) <span class="cov8" title="1">{
        //TODO: check user's role
        requiredRole := ""
        access, err := checkRole(userCollection, request.GetUser().GetId(), requiredRole)
        if !access </span><span class="cov0" title="0">{
                return &amp;editor.EditCommentArticleResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">id, _ := primitive.ObjectIDFromHex(request.ArticleId)
        article, err := articleCollection.Get(id)
        if err != nil || article == nil </span><span class="cov0" title="0">{
                return &amp;editor.EditCommentArticleResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">commentID, _ := primitive.ObjectIDFromHex(request.Comment.Id)
        for i, comment := range article.Comments </span><span class="cov8" title="1">{
                if comment.Id == commentID </span><span class="cov8" title="1">{
                        article.Comments[i].Content = request.Comment.Content
                        article.Comments[i].Author = model.RenderBackUserModel(request.Comment.Author)
                }</span>
        }
        <span class="cov8" title="1">err = articleCollection.Update(article)
        if err != nil </span><span class="cov0" title="0">{
                return &amp;editor.EditCommentArticleResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">return &amp;editor.EditCommentArticleResponse{
                Success: true,
        }, nil</span>
}

func (server *serverImpl) DeleteCommentArticle(ctx context.Context, request *editor.DeleteCommentArticleRequest) (*editor.DeleteCommentArticleResponse, error) <span class="cov8" title="1">{
        //TODO: check user's role
        requiredRole := ""
        access, err := checkRole(userCollection, request.GetUser().GetId(), requiredRole)
        if !access </span><span class="cov0" title="0">{
                return &amp;editor.DeleteCommentArticleResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">id, _ := primitive.ObjectIDFromHex(request.ArticleId)
        article, err := articleCollection.Get(id)
        if err != nil || article == nil </span><span class="cov0" title="0">{
                return &amp;editor.DeleteCommentArticleResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">commentID, _ := primitive.ObjectIDFromHex(request.CommentId)
        for i, comment := range article.Comments </span><span class="cov8" title="1">{
                if comment.Id == commentID </span><span class="cov8" title="1">{
                        article.Comments = append(article.Comments[:i], article.Comments[i+1:]...)
                }</span>
        }
        <span class="cov8" title="1">err = articleCollection.Update(article)
        if err != nil </span><span class="cov0" title="0">{
                return &amp;editor.DeleteCommentArticleResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">return &amp;editor.DeleteCommentArticleResponse{
                Success: true,
        }, nil</span>
}

func (server *serverImpl) ArchiveCommentArticle(ctx context.Context, request *editor.ArchiveCommentArticleRequest) (*editor.ArchiveCommentArticleResponse, error) <span class="cov8" title="1">{
        //TODO: check user's role
        requiredRole := ""
        access, err := checkRole(userCollection, request.GetUser().GetId(), requiredRole)
        if !access </span><span class="cov0" title="0">{
                return &amp;editor.ArchiveCommentArticleResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">id, _ := primitive.ObjectIDFromHex(request.ArticleId)
        article, err := articleCollection.Get(id)
        if err != nil || article == nil </span><span class="cov0" title="0">{
                return &amp;editor.ArchiveCommentArticleResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">commentID, _ := primitive.ObjectIDFromHex(request.CommentId)
        for i, comment := range article.Comments </span><span class="cov8" title="1">{
                if comment.Id == commentID </span><span class="cov8" title="1">{
                        article.ArchiveComments = append(
                                article.ArchiveComments,
                                &amp;model.Comment{
                                        Id:      comment.Id,
                                        Author:  comment.Author,
                                        Content: comment.Content,
                                })
                        article.Comments = append(article.Comments[:i], article.Comments[i+1:]...)
                }</span>
        }
        <span class="cov8" title="1">err = articleCollection.Update(article)
        if err != nil </span><span class="cov0" title="0">{
                return &amp;editor.ArchiveCommentArticleResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">return &amp;editor.ArchiveCommentArticleResponse{
                Success: true,
        }, nil</span>
}

func (server *serverImpl) AppointmentToResponsibleEditor(ctx context.Context, request *editor.AppointmentToResponsibleEditorRequest) (*editor.AppointmentToResponsibleEditorResponse, error) <span class="cov8" title="1">{
        //TODO: check user's role
        requiredRole := ""
        access, err := checkRole(userCollection, request.GetUser().GetId(), requiredRole)
        if !access </span><span class="cov0" title="0">{
                return &amp;editor.AppointmentToResponsibleEditorResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">id, _ := primitive.ObjectIDFromHex(request.ArticleId)
        article, err := articleCollection.Get(id)
        if err != nil || article == nil </span><span class="cov0" title="0">{
                return &amp;editor.AppointmentToResponsibleEditorResponse{
                        Success: false,
                }, err
        }</span>
        <span class="cov8" title="1">article.ResponsibleEditor = model.RenderBackUserModel(request.User)
        err = articleCollection.Update(article)
        if err != nil </span><span class="cov0" title="0">{
                return &amp;editor.AppointmentToResponsibleEditorResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">return &amp;editor.AppointmentToResponsibleEditorResponse{
                Success: true,
        }, nil</span>
}

func (server *serverImpl) AppointmentToSectionEditor(ctx context.Context, request *editor.AppointmentToSectionEditorRequest) (*editor.AppointmentToSectionEditorResponse, error) <span class="cov8" title="1">{
        //TODO: check user's role
        requiredRole := ""
        access, err := checkRole(userCollection, request.GetUser().GetId(), requiredRole)
        if !access </span><span class="cov0" title="0">{
                return &amp;editor.AppointmentToSectionEditorResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">id, _ := primitive.ObjectIDFromHex(request.ArticleId)
        article, err := articleCollection.Get(id)
        if err != nil || article == nil </span><span class="cov0" title="0">{
                return &amp;editor.AppointmentToSectionEditorResponse{
                        Success: false,
                }, err
        }</span>
        <span class="cov8" title="1">article.Section.SectionEditor = model.RenderBackUserModel(request.User)
        err = articleCollection.Update(article)
        if err != nil </span><span class="cov0" title="0">{
                return &amp;editor.AppointmentToSectionEditorResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">return &amp;editor.AppointmentToSectionEditorResponse{
                Success: true,
        }, nil</span>
}

func (server *serverImpl) AppointmentToSectionAuthor(ctx context.Context, request *editor.AppointmentToSectionAuthorRequest) (*editor.AppointmentToSectionAuthorResponse, error) <span class="cov8" title="1">{
        //TODO: check user's role
        requiredRole := ""
        access, err := checkRole(userCollection, request.GetUser().GetId(), requiredRole)
        if !access </span><span class="cov0" title="0">{
                return &amp;editor.AppointmentToSectionAuthorResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">id, _ := primitive.ObjectIDFromHex(request.ArticleId)
        article, err := articleCollection.Get(id)
        if err != nil || article == nil </span><span class="cov0" title="0">{
                return &amp;editor.AppointmentToSectionAuthorResponse{
                        Success: false,
                }, err
        }</span>
        <span class="cov8" title="1">article.Section.SectionAuthor = model.RenderBackUserModel(request.User)
        err = articleCollection.Update(article)
        if err != nil </span><span class="cov0" title="0">{
                return &amp;editor.AppointmentToSectionAuthorResponse{
                        Success: false,
                }, err
        }</span>

        <span class="cov8" title="1">return &amp;editor.AppointmentToSectionAuthorResponse{
                Success: true,
        }, nil</span>
}

//TODO: check user's role
func checkRole(userCollection model.DBInterfaceUser, userID string, requiredRole string) (bool, error) <span class="cov8" title="1">{
        id, _ := primitive.ObjectIDFromHex(userID)
        role, err := userCollection.GetRole(id)
        if err != nil || role != requiredRole </span><span class="cov0" title="0">{
                return false, err
        }</span>

        <span class="cov8" title="1">return true, nil</span>
}
</pre>
		
		<pre class="file" id="file2" style="display: none">package impl

import (
        "context"
        log "github.com/sirupsen/logrus"
        editor "gitlab.com/editorservice/backend/editor/api"
        "gitlab.com/editorservice/backend/editor/db"
        "google.golang.org/grpc"
        "net"
)

var (
        userCollection    = db.GetUserDB(context.TODO())
        articleCollection = db.GetArticleDB(context.TODO())
)

type Server interface {
        editor.EditorServiceServer
        Serve(addr string)
}

type serverImpl struct {
}

func NewServer() Server <span class="cov8" title="1">{
        server := &amp;serverImpl{}
        return server
}</span>

func (server *serverImpl) Serve(addr string) <span class="cov8" title="1">{
        if listener, err := net.Listen("tcp", addr); err != nil </span><span class="cov0" title="0">{
                panic(err)</span>
        } else<span class="cov8" title="1"> {
                grpcServer := grpc.NewServer()
                editor.RegisterEditorServiceServer(grpcServer, server)
                log.Info("Editor Service started")
                if err := grpcServer.Serve(listener); err != nil </span><span class="cov0" title="0">{
                        panic(err)</span>
                }
        }
}
</pre>
		
		<pre class="file" id="file3" style="display: none">package model

import (
        editor "gitlab.com/editorservice/backend/editor/api"
        "go.mongodb.org/mongo-driver/bson/primitive"
)

type Article struct {
        Id                primitive.ObjectID `bson:"_id"`
        Status            string             `bson:"status"`
        Author            *User              `bson:"author"`
        Name              string             `bson:"name"`
        CreatedAt         string             `bson:"created_at"`
        UpdatedAt         string             `bson:"updated_at"`
        Content           string             `bson:"content"`
        Comments          []*Comment         `bson:"comments"`
        ArchiveComments   []*Comment         `bson:"archive_comments"`
        Versions          []*Version         `bson:"versions"`
        TemplateID        primitive.ObjectID `bson:"template_id"`
        AttachedArticles  []*Article         `bson:"attached_articles"`
        CurrentVersion    int64              `bson:"current_version"`
        ResponsibleEditor *User              `bson:"responsible_editor"`
        Section           *Section           `bson:"section"`
        Reviewer          *User              `bson:"reviewer"`
        Review            string             `bson:"review"`
        CuratorConsultant *User              `bson:"curator_consultant"`
}

type Section struct {
        SectionEditor *User  `bson:"section_editor"`
        SectionAuthor *User  `bson:"section_author"`
        Name          string `bson:"name"`
        Content       string `bson:"content"`
}

type Version struct {
        Article   *Article `bson:"article"`
        CreatedAt string   `bson:"created_at"`
}

type Comment struct {
        Id      primitive.ObjectID `bson:"_id"`
        Author  *User              `bson:"author"`
        Content string             `bson:"content"`
}

func RenderArticleCommentModel(model *Comment) *editor.Comment <span class="cov0" title="0">{
        result := &amp;editor.Comment{}
        var commentID interface{}
        commentID = model.Id
        result = &amp;editor.Comment{
                Id:      commentID.(primitive.ObjectID).Hex(),
                Author:  RenderUserModel(model.Author),
                Content: model.Content,
        }
        return result
}</span>

func RenderBackArticleCommentModel(model *editor.Comment) *Comment <span class="cov0" title="0">{
        result := &amp;Comment{}
        commentID, _ := primitive.ObjectIDFromHex(model.GetId())
        result = &amp;Comment{
                Id:      commentID,
                Author:  RenderBackUserModel(model.GetAuthor()),
                Content: model.GetContent(),
        }
        return result
}</span>

func RenderArticleListCommentModel(model []*Comment) []*editor.Comment <span class="cov8" title="1">{
        var (
                commentID interface{}
                comments  []*editor.Comment
        )

        for _, c := range model </span><span class="cov8" title="1">{
                commentID = c.Id

                comments = append(comments, &amp;editor.Comment{
                        Id:      commentID.(primitive.ObjectID).Hex(),
                        Author:  RenderUserModel(c.Author),
                        Content: c.Content,
                })
        }</span>
        <span class="cov8" title="1">return comments</span>
}

func RenderBackArticleListCommentModel(model []*editor.Comment) []*Comment <span class="cov8" title="1">{
        var comments []*Comment

        for _, c := range model </span><span class="cov8" title="1">{
                commentID, _ := primitive.ObjectIDFromHex(c.GetId())

                comments = append(comments, &amp;Comment{
                        Id:      commentID,
                        Author:  RenderBackUserModel(c.GetAuthor()),
                        Content: c.GetContent(),
                })
        }</span>
        <span class="cov8" title="1">return comments</span>
}

func RenderArticleVersionModel(model []*Version) []*editor.VersionArticle <span class="cov8" title="1">{
        var versions []*editor.VersionArticle

        for _, v := range model </span><span class="cov8" title="1">{
                versions = append(versions, &amp;editor.VersionArticle{
                        Article:   RenderArticleModel(v.Article),
                        CreatedAt: v.CreatedAt,
                })
        }</span>
        <span class="cov8" title="1">return versions</span>
}

func RenderBackArticleVersionModel(model []*editor.VersionArticle) []*Version <span class="cov8" title="1">{
        var versions []*Version

        for _, v := range model </span><span class="cov8" title="1">{
                versions = append(versions, &amp;Version{
                        Article:   RenderBackArticleModel(v.GetArticle()),
                        CreatedAt: v.GetCreatedAt(),
                })
        }</span>
        <span class="cov8" title="1">return versions</span>
}

func RenderSectionArticleModel(model *Section) *editor.Section <span class="cov8" title="1">{
        result := &amp;editor.Section{}
        if model != nil </span><span class="cov8" title="1">{
                result = &amp;editor.Section{
                        SectionEditor: RenderUserModel(model.SectionEditor),
                        SectionAuthor: RenderUserModel(model.SectionAuthor),
                        Name:          model.Name,
                        Content:       model.Content,
                }
        }</span>
        <span class="cov8" title="1">return result</span>
}

func RenderBackSectionArticleModel(model *editor.Section) *Section <span class="cov8" title="1">{
        result := &amp;Section{}
        result = &amp;Section{
                SectionEditor: RenderBackUserModel(model.GetSectionEditor()),
                SectionAuthor: RenderBackUserModel(model.GetSectionAuthor()),
                Name:          model.GetName(),
                Content:       model.GetContent(),
        }
        return result
}</span>

func RenderListArticleModel(model []*Article) []*editor.Article <span class="cov8" title="1">{
        var versions []*editor.Article

        for _, a := range model </span><span class="cov0" title="0">{
                versions = append(versions, RenderArticleModel(a))
        }</span>
        <span class="cov8" title="1">return versions</span>
}

func RenderBackListArticleModel(model []*editor.Article) []*Article <span class="cov8" title="1">{
        var versions []*Article

        for _, a := range model </span><span class="cov0" title="0">{
                versions = append(versions, RenderBackArticleModel(a))
        }</span>
        <span class="cov8" title="1">return versions</span>
}

func RenderBackArticleModel(model *editor.Article) *Article <span class="cov8" title="1">{
        result := &amp;Article{}
        articleID, _ := primitive.ObjectIDFromHex(model.GetId())
        templateID, _ := primitive.ObjectIDFromHex(model.GetTemplateId())

        result = &amp;Article{
                Id:                articleID,
                Status:            model.GetStatus(),
                Author:            RenderBackUserModel(model.GetAuthor()),
                Name:              model.GetName(),
                CreatedAt:         model.GetCreatedAt(),
                UpdatedAt:         model.GetUpdatedAt(),
                Content:           model.GetContent(),
                Comments:          RenderBackArticleListCommentModel(model.GetComments()),
                ArchiveComments:   RenderBackArticleListCommentModel(model.GetComments()),
                Versions:          RenderBackArticleVersionModel(model.GetVersions()),
                TemplateID:        templateID,
                AttachedArticles:  RenderBackListArticleModel(model.GetAttachedArticles()),
                CurrentVersion:    model.GetCurrentVersion(),
                ResponsibleEditor: RenderBackUserModel(model.GetResponsibleEditor()),
                Reviewer:          RenderBackUserModel(model.GetReviewer()),
                Review:            model.GetReview(),
                CuratorConsultant: RenderBackUserModel(model.GetCuratorConsultant()),
                Section:           RenderBackSectionArticleModel(model.GetSection()),
        }
        return result
}</span>

func RenderArticleModel(model *Article) *editor.Article <span class="cov8" title="1">{
        result := &amp;editor.Article{}
        var (
                articleID  interface{} = model.Id
                templateID interface{} = model.TemplateID
        )

        result = &amp;editor.Article{
                Id:                articleID.(primitive.ObjectID).Hex(),
                Status:            model.Status,
                Author:            RenderUserModel(model.Author),
                Name:              model.Name,
                CreatedAt:         model.CreatedAt,
                UpdatedAt:         model.UpdatedAt,
                Content:           model.Content,
                Comments:          RenderArticleListCommentModel(model.Comments),
                ArchiveComments:   RenderArticleListCommentModel(model.ArchiveComments),
                Versions:          RenderArticleVersionModel(model.Versions),
                TemplateId:        templateID.(primitive.ObjectID).Hex(),
                AttachedArticles:  RenderListArticleModel(model.AttachedArticles),
                CurrentVersion:    model.CurrentVersion,
                ResponsibleEditor: RenderUserModel(model.ResponsibleEditor),
                Reviewer:          RenderUserModel(model.Reviewer),
                Review:            model.Review,
                CuratorConsultant: RenderUserModel(model.CuratorConsultant),
                Section:           RenderSectionArticleModel(model.Section),
        }
        return result
}</span>

type DBInterfaceArticle interface {
        Create(article *Article) error
        Get(id primitive.ObjectID) (*Article, error)
        GetByVersion(id primitive.ObjectID, versionNumber int64) (*Article, error)
        GetList() ([]*Article, error)
        Update(article *Article) error
        Delete(id primitive.ObjectID) error
}
</pre>
		
		<pre class="file" id="file4" style="display: none">package model

import (
        editor "gitlab.com/editorservice/backend/editor/api"
        "go.mongodb.org/mongo-driver/bson/primitive"
)

type User struct {
        Id         primitive.ObjectID `bson:"_id"`
        FirstName  string             `bson:"first_name"`
        MiddleName string             `bson:"middle_name"`
        LastName   string             `bson:"last_name"`
        Role       string             `bson:"role"`
}

func RenderUserModel(model *User) *editor.User <span class="cov8" title="1">{
        result := &amp;editor.User{}
        if model != nil </span><span class="cov8" title="1">{
                var userID interface{}
                userID = model.Id

                result = &amp;editor.User{
                        Id:         userID.(primitive.ObjectID).Hex(),
                        FirstName:  model.FirstName,
                        MiddleName: model.MiddleName,
                        LastName:   model.LastName,
                        Role:       model.Role,
                }
        }</span>
        <span class="cov8" title="1">return result</span>
}

func RenderBackUserModel(model *editor.User) *User <span class="cov8" title="1">{
        result := &amp;User{}
        userID, _ := primitive.ObjectIDFromHex(model.GetId())

        result = &amp;User{
                Id:         userID,
                FirstName:  model.GetFirstName(),
                MiddleName: model.GetMiddleName(),
                LastName:   model.GetLastName(),
                Role:       model.GetRole(),
        }
        return result
}</span>

type DBInterfaceUser interface {
        FindByID(id primitive.ObjectID) (*User, error)
        GetRole(id primitive.ObjectID) (string, error)
        Create(user *User) error
        Delete(id primitive.ObjectID) error
}
</pre>
		
		</div>
	</body>
	<script>
	(function() {
		var files = document.getElementById('files');
		var visible;
		files.addEventListener('change', onChange, false);
		function select(part) {
			if (visible)
				visible.style.display = 'none';
			visible = document.getElementById(part);
			if (!visible)
				return;
			files.value = part;
			visible.style.display = 'block';
			location.hash = part;
		}
		function onChange() {
			select(files.value);
			window.scrollTo(0, 0);
		}
		if (location.hash != "") {
			select(location.hash.substr(1));
		}
		if (!visible) {
			select("file0");
		}
	})();
	</script>
</html>
